ljPost = new Object();

// START ljPost SECTION...

ljPost.startPost = function() {
	// Starts posting. Requests a challenge from the server.
	// In: Nothing.
	// Out: Nothing.
	this.httpreq = new XMLHttpRequest()
	this.httpreq.onload = this.challengeHandler.onResult;
	this.httpreq.onerror = this.challengeHandler.onError;
	this.httpreq.open("POST", LiveJournal.posturl, true);
	this.httpreq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	this.httpreq.send("mode=getchallenge");
	document.getElementById("statuswhat").value = "Requesting challenge...";
}

ljPost.challengeHandler = {
	// Amazing, we have a challenge! Time to start sending the post. Which requires calling the postToServer function!
	// In: Nothing.
	// Out: Nothing.
	onResult: function() {
		if (dsPosts.posting) {
			if (LiveJournal.getResponseData("success", ljPost.httpreq.responseText) == "OK") {
				var challenge = LiveJournal.getResponseData("challenge", ljPost.httpreq.responseText);
				ljPost.postToServer(challenge);
			} else {
				alert("There was an error with the request: " + LiveJournal.getResponseData("errmsg", ljPost.httpreq.responseText));
				dsPosts.sendPost();
			}
		}
	},
	onError: function () {
		if (dsPosts.posting) {
			alert("There was an error connecting to the server.");
			dsPosts.sendPost();
		}
	}
}

ljPost.postToServer = function(challengestring) {
	// Sends the post to the server. Hurrah!
	// In: Nothing.
	// Out: Nothing.
	this.httpreq = new XMLHttpRequest();
	this.httpreq.onload = this.postHandler.onResult;
	this.httpreq.onerror = this.postHandler.onError;
	this.httpreq.open("POST", LiveJournal.posturl, true);
	var params = new Object();
	
	params.user = LiveJournal.username;
	params.auth_method = "challenge";
	params.auth_challenge = challengestring;
	params.auth_response = hexMD5(challengestring + hexMD5(LiveJournal.password));
	params.ver = 1;
	params.clientversion = AppName;
	// Always use \n as the line ending... Makes life much easier, especially across platforms.
	params.lineendings = "unix";
	var subjectbox = document.getElementById("subject");
	if (subjectbox.value.trim().length > 0) {
		params.subject = subjectbox.value;
	}
	dsMidas.updateSourceTab();
	params.event = document.getElementById("messagesource").value;
	switch (this.security) {
		case 0:
			params.security = "public";
			break;
		case 1:
			params.security = "private";
			break;
		case 2:
			params.security = "usemask";
			params.allowmask = this.allowmask;
			break;
	}
	var now = new Date();
	params.year = now.getYear() + 1900;
	params.mon = now.getMonth() + 1;
	params.day = now.getDate();
	params.hour = now.getHours();
	params.min = now.getMinutes();
	
	if (this.usejournal != LiveJournal.username) {
		params.usejournal = this.usejournal;
	}

	var moodbox = document.getElementById("moods"); 
	if ((moodbox.selectedIndex < 0) && (moodbox.label.trim().length > 0)) {
		params.prop_current_mood = moodbox.label;
	} else if (moodbox.selectedIndex >= 0) {
		params.prop_current_moodid = LiveJournal.moods[moodbox.selectedIndex].id;
	}
	
	var musicbox = document.getElementById("music");
	if (musicbox.value.trim().length > 0) {
		params.prop_current_music = musicbox.value.trim();
	}
	
	if (this.dontautoformat.toString() == "true") {
		params.prop_opt_preformatted = 1;
	}
	
	if (this.removecomments.toString() == "true") {
		params.prop_opt_nocomments = 1;
	}
	
	if (this.backdate.toString() == "true") {
		params.prop_opt_backdated = 1;
	}
	
	var pickwbox = document.getElementById("picture");
	if (pickwbox.selectedIndex > 0) {
		params.prop_picture_keyword = this.pickw;
	}
	
	var body = "mode=postevent";
	body += LiveJournal.makeParams(params);

	document.getElementById("statuswhat").value = "Posting to journal: " + this.usejournal;
	this.httpreq.send(body);
}

ljPost.postHandler = {
	// Handle my post, dammit. Runs when the server has returned a response from the actual post.
	// In: Nothing.
	// Out: Nothing.
	onResult: function() {
		if (dsPosts.posting) {
			if (LiveJournal.getResponseData("success", ljPost.httpreq.responseText) == "OK") {
			// Posted!
			dsPosts.resetPostParameters();
			dsPosts.sendPost();
			} else {
				alert("There was an error with the request: " + LiveJournal.getResponseData("errmsg", ljPost.httpreq.responseText));
				dsPosts.sendPost();
			}
		}
	},
	onError: function () {
		if (dsPosts.posting) {
			alert("There was an error connecting to the server.");
			dsPosts.sendPost();
		}
	}
}
